using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TrickyBoxing
{
    // Listing 7-18
    public struct DisposableValue : IDisposable
    {
        private bool _disposedYet;

        public void Dispose()
        {
            if (!_disposedYet)
            {
                Console.WriteLine("Zwalniamy po raz pierwszy.");
                _disposedYet = true;
            }
            else
            {
                Console.WriteLine("Obiekt już został zwolniony.");
            }
        }
    }

    class Program
    {
        static void CallDispose(IDisposable o)
        {
            o.Dispose();
        }

        static void Main(string[] args)
        {
            var dv = new DisposableValue();
            Console.WriteLine("Przekazujemy zmienną wartościową:");
            CallDispose(dv);
            CallDispose(dv);
            CallDispose(dv);

            IDisposable id = dv;
            Console.WriteLine("Przekazujemy zmienną typu interfejsu:");
            CallDispose(id);
            CallDispose(id);
            CallDispose(id);

            Console.WriteLine("Wywołujemy metodę Dispose bezpośrednio na zmiennej typu wartościowego:");
            dv.Dispose();
            dv.Dispose();
            dv.Dispose();
        }
    }

}
